<?php

namespace QUI\Registration\WalletConnect;

use QUI;
use QUI\FrontendUsers;
use QUI\FrontendUsers\InvalidFormField;

/**
 * Class Registrar
 */
class Registrar extends FrontendUsers\AbstractRegistrar
{
    /**
     * Registrar constructor.
     */
    public function __construct()
    {
        $this->setAttribute('icon-css-class', 'walletconnect-registrar');
    }

    /**
     * @param QUI\Interfaces\Users\User $User
     * @return void
     */
    public function onRegistered(QUI\Interfaces\Users\User $User)
    {

    }

    /**
     * Return the success message
     * @return string
     */
    public function getSuccessMessage()
    {
        return '';
    }

    /**
     * @throws FrontendUsers\Exception
     */
    public function validate()
    {

    }

    /**
     * Get all invalid registration form fields
     *
     * @return InvalidFormField[]
     */
    public function getInvalidFields()
    {
        // Registration via WalletConnect account does not use form fields
        return [];
    }

    /**
     * @return string
     */
    public function getUsername()
    {
        return '';
    }

    /**
     * @return RegistrationControl
     */
    public function getControl()
    {
        return new RegistrationControl();
    }

    /**
     * Get title
     *
     * @param QUI\Locale $Locale (optional) - If omitted use QUI::getLocale()
     * @return string
     */
    public function getTitle($Locale = null)
    {
        if (is_null($Locale)) {
            $Locale = QUI::getLocale();
        }

        return $Locale->get('quiqqer/authwalletconnect', 'registrar.title');
    }

    /**
     * Get description
     *
     * @param QUI\Locale $Locale (optional) - If omitted use QUI::getLocale()
     * @return string
     */
    public function getDescription($Locale = null)
    {
        if (is_null($Locale)) {
            $Locale = QUI::getLocale();
        }

        return $Locale->get('quiqqer/authwalletconnect', 'registrar.description');
    }

    /**
     * @return string
     */
    public function getIcon()
    {
        return URL_OPT_DIR.'quiqqer/authwalletconnect/bin/WalletConnectLogo.png';
    }

    /**
     * Check if this Registrar can send passwords
     *
     * @return bool
     */
    public function canSendPassword()
    {
        return false;
    }
}
